// ExtPackageShape.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "ExtPackageShape.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// CExtPackageShape Class
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
IMPLEMENT_SERIAL(CExtPackageShape, CFODrawPortsShape, 0)
CExtPackageShape::CExtPackageShape()
{
	SetType(MY_PACK_SHAPE); // you must asign a new ID for this control.
	SetPolyObject(TRUE);
}

CExtPackageShape::CExtPackageShape(const CExtPackageShape& src)
{
	*this = src;
}

CExtPackageShape::~CExtPackageShape()
{

}

/////////////////////////////////////////////////////////////////////////////
// CExtPackageShape diagnostics

#ifdef _DEBUG
void CExtPackageShape::AssertValid() const
{
	CFODrawPortsShape::AssertValid();
}

void CExtPackageShape::Dump(CDumpContext& dc) const
{
	CFODrawPortsShape::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////

#define AADL_PORT_MAX_OUT 20

void CExtPackageShape::Create(CRect &rcPos,CString strCaption)
{
// Example code:
	int x, y, w, h;

	x = rcPos.left;
	y = rcPos.top;
	w = rcPos.Width();
	h = rcPos.Height();

	AllocMemory(9);
	m_lpShapePoints[0] = CPoint(rcPos.left,  rcPos.top);
	m_lpShapePoints[1] = CPoint(rcPos.right, rcPos.top);
	m_lpShapePoints[2] = CPoint(rcPos.right, rcPos.bottom);
	m_lpShapePoints[3] = CPoint(rcPos.left,  rcPos.bottom);

	m_lpShapePoints[0].x = x;                 m_lpShapePoints[0].y = y + AADL_PORT_MAX_OUT;
	m_lpShapePoints[1].x = CFODrawHelper::RoundValue(x + 0.03 * w) ;     m_lpShapePoints[1].y = y + AADL_PORT_MAX_OUT;
	m_lpShapePoints[2].x = CFODrawHelper::RoundValue(x + 0.08 * w) ;     m_lpShapePoints[2].y = y;
	m_lpShapePoints[3].x = CFODrawHelper::RoundValue(x + 0.40 * w) ;     m_lpShapePoints[3].y = y;
	m_lpShapePoints[4].x = CFODrawHelper::RoundValue(x + 0.45 * w) ;     m_lpShapePoints[4].y = y + AADL_PORT_MAX_OUT;
	m_lpShapePoints[5].x = CFODrawHelper::RoundValue(x + w - 0.05 * w);  m_lpShapePoints[5].y = y + AADL_PORT_MAX_OUT;
	m_lpShapePoints[6].x = x + w;             m_lpShapePoints[6].y = y +  + AADL_PORT_MAX_OUT+ CFODrawHelper::RoundValue(0.05 * h);
	m_lpShapePoints[7].x = x + w;             m_lpShapePoints[7].y = y + h;
	m_lpShapePoints[8].x = x ;                m_lpShapePoints[8].y = y + h;

	CFODrawPortsShape::Create(rcPos,strCaption);
	CreateDefaultPort(0.5,0.5);

}

void CExtPackageShape::Serialize(CArchive& ar)
{
	CFODrawPortsShape::Serialize(ar);
	if(ar.IsStoring())
	{
		//FODO:Add your own code here.

	}
	else
	{
		//FODO:Add your own code here.

	}
}

/////////////////////////////////////////////////////////////////////////////
// CPrintBaseJob serialization
CFile* CExtPackageShape::GetFile(LPCTSTR lpszFileName, UINT nOpenFlags,
								 CFileException* pError)
{
	CMirrorFile* pFile = new CMirrorFile;
	ASSERT(pFile != NULL);
	if (!pFile->Open(lpszFileName, nOpenFlags, pError))
	{
		delete pFile;
		pFile = NULL;
	}
	return pFile;
}

void CExtPackageShape::ReleaseFile(CFile* pFile, BOOL bAbort)
{
	ASSERT_KINDOF(CFile, pFile);
	if (bAbort)
		pFile->Abort(); // will not throw an exception
	else
		pFile->Close();
	delete pFile;
}

BOOL CExtPackageShape::OpenDocument(LPCTSTR lpszPathName)
{
	
	CFileException fe;
	CFile* pFile = GetFile(lpszPathName,
		CFile::modeRead|CFile::shareDenyWrite, &fe);
	if (pFile == NULL)
	{
		return FALSE;
	}
	
	CArchive loadArchive(pFile, CArchive::load | CArchive::bNoFlushOnDelete);
	loadArchive.m_bForceFlat = FALSE;
	TRY
	{
		CWaitCursor wait;
		if (pFile->GetLength() != 0)
			Serialize(loadArchive);     // load me
		loadArchive.Close();
		ReleaseFile(pFile, FALSE);
	}
	CATCH_ALL(e)
	{
		ReleaseFile(pFile, TRUE);
		
		return FALSE;
	}
	END_CATCH_ALL
		
		
		return TRUE;
}

BOOL CExtPackageShape::SaveDocument(LPCTSTR lpszPathName)
{
	
	CFileException fe;
	CFile* pFile = NULL;
	pFile = GetFile(lpszPathName, CFile::modeCreate |
		CFile::modeReadWrite | CFile::shareExclusive, &fe);
	
	if (pFile == NULL)
	{
		
		return FALSE;
	}
	
	CArchive saveArchive(pFile, CArchive::store | CArchive::bNoFlushOnDelete);
	saveArchive.m_bForceFlat = FALSE;
	TRY
	{
		CWaitCursor wait;
		Serialize(saveArchive);     // save me
		saveArchive.Close();
		ReleaseFile(pFile, FALSE);
	}
	CATCH_ALL(e)
	{
		ReleaseFile(pFile, TRUE);
		
		return FALSE;
	}
	END_CATCH_ALL
		
		
		return TRUE;        // success
}


CExtPackageShape& CExtPackageShape::operator=(const CExtPackageShape& src)
{
	(*(CFODrawPortsShape*)this) = src;
	return (*this);
}

CFODrawShape* CExtPackageShape::Copy() const
{
	return (new CExtPackageShape(*this));
}

void CExtPackageShape::PrepareDC(CDC* pDC)
{
	CFODrawPortsShape::PrepareDC(pDC);

	//FODO:Add your own code below.
	
}

void CExtPackageShape::GetPathSimplePolygon(FOPSimpleCompositePolygon& rPoly) const
{
	CFODrawPortsShape::GetPathSimplePolygon(rPoly);

}

void CExtPackageShape::OnDrawTrackCustom(CDC *pDC)
{
	CFODrawPortsShape::OnDrawTrackCustom(pDC);

	// Add your own code here.
}

void CExtPackageShape::DoDrawVisioOrderLine(CDC *pDC)
{
	CFODrawPortsShape::DoDrawVisioOrderLine(pDC);

	//FODO:Add your own code below.
	
}

void CExtPackageShape::OnDrawFlat(CDC *pDC)
{
	CFODrawPortsShape::OnDrawFlat(pDC);

	//FODO:Add your own code below.

// Example code:
	FillPoly(pDC,m_lpShapePoints, m_nCompPtCount,GetBkColor(),
		GetPatternColor(),GetBrushType());

}

void CExtPackageShape::OnDrawShadow(CDC *pDC)
{
	CFODrawPortsShape::OnDrawShadow(pDC);

	//FODO:Add your own code below.

// Example code:
	FillShadowPoly(pDC,m_lpShapePoints, m_nCompPtCount);
}

void CExtPackageShape::OnDraw3d(CDC *pDC)
{
	CFODrawPortsShape::OnDraw3d(pDC);
	
	//FODO:Add your own code below.

// Example code:
	FillPoly(pDC,m_lpShapePoints, m_nCompPtCount,GetBkColor(),
		GetPatternColor(),GetBrushType());

}

void CExtPackageShape::ClearDC(CDC* pDC)
{
	CFODrawPortsShape::ClearDC(pDC);

	//FODO:Add your own code below.

}

void CExtPackageShape::GeometryUpdated(CFOArea* pRgn)
{

// Example code:
	if (m_lpShapePoints && pRgn)
	{
		pRgn->BuildPolygonArea(m_lpShapePoints, m_nCompPtCount);
		m_rectPosition = pRgn->GetBoundingRect();
	}

}
